﻿# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-35. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
В командных олимпиадах по программированию для решения предлагается не
более 12 задач. Команда может решать предложенные задачи в любом
порядке. Подготовленные решения команда посылает в единую проверяющую
систем соревнований. Вам предлагается написать эффективную, в том числе
и по используемой памяти, программу, которая будет статистически
обрабатывать пришедшие запросы на проверку, чтобы определить
популярность той или иной задачи. Следует учитывать, что количество
запросов в списке может быть очень велико, например, когда олимпиада
проводится через Интернет. перед текстом программы кратко опишите
используемый вами алгоритм решения задачи. На вход программе в первой
строчке подается количество пришедших запросов N. В каждой из
последующих N строк записан номер задачи от 1 до 12. Пример входных
данных:
    6
    1
    2
    1
    1
    5
    2
Программа должна вывести список всех задач, встречающихся в запросах, в 
порядке возрастания (неубывания) количества запросов по ней с указанием 
этого количества запросов. Каждая задача должна быть выведена только
один раз. Пример выходных данных для приведенных входных данных:
    5 1
    2 2
    1 3
"""
import sys
save_stdin = sys.stdin
sys.stdin = open("in/35.in")

N = int(input())
cnt = {}
for i in range(N):
    n = int(input())
    cnt[n-1] = cnt.get(n-1,0) + 1

cnt = sorted(cnt.items(), key = lambda x: x[1])
for x in cnt:
    print(x[0]+1, x[1])

sys.stdin = save_stdin