﻿# -*- coding: utf-8 -*-
"""
-------------------------------------------------
Задача C4-38. 
Решение на языке Python 3.
 Автор: Константин Поляков, 2013
E-mail: kpolyakov@mail.ru
   Web: kpolyakov.spb.ru
-------------------------------------------------
По каналу связи передается последовательность положительных целых чисел
X1, X2, …; все числа не превышают 1000, их количество заранее
неизвестно. Каждое число передается в виде отдельной текстовой строки,
содержащей десятичную запись числа. Признаком конца передаваемой 
последовательности является число 0. 
Участок последовательности от элемента XT до элемента XT+N называется
подъемом, если на этом участке каждое следующее число больше
предыдущего. Высотой подъема называется разность X[T+N] - XT.
Напишите эффективную программу, которая вычисляет наибольшую высоту 
среди всех подъемов последовательности. Если в последовательности нет ни
одного подъема, программа выдает 0. Программа должна напечатать отчет по
следующей форме:
    Получено ... чисел
    Наибольшая высота подъема: ...
Размер памяти, которую использует Ваша программа, не должен зависеть от
длины переданной последовательности чисел.
"""
import sys
save_stdin = sys.stdin
sys.stdin = open("in/38.in")

count = 0
maxHeight = 0
curHeight = 0
xPrev = 1001 
while True:
    x = int(input())
    if x == 0: break
    count += 1
    if x > xPrev:
        curHeight = curHeight + x - xPrev
        if curHeight > maxHeight:
            maxHeight = curHeight
    else:
       curHeight = 0
    xPrev = x

print('Получено %d чисел' % (count));
print('Наибольшая высота подъема', maxHeight);

sys.stdin = save_stdin